#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	public enum Round
	{
		Ceil,
		Floor,
		Truncate,
		ToEven,
		AwayFromZero
	};
	
	#region PluginInfo
	[PluginInfo(Name = "Round", Category = "Value", Help = ".net Math.Round function", Tags = "")]
	#endregion PluginInfo
	public class ValueRoundNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultValue = 1.0)]
		public ISpread<double> FInput;
		
		[Input("Digits", DefaultValue = 1, MinValue = 0)]
		public ISpread<int> FDigits;
		
		[Input("Rounding")]
		public ISpread<Round> FRounding;
		
		[Output("Output")]
		public ISpread<double> FOutput;
		#endregion fields & pins
		
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			
			for (int i = 0; i < SpreadMax; i++)
			
			if (FRounding[i] == Round.Ceil)
			{
				double d = Math.Pow(10, FDigits[i]);
				FOutput[i] = Math.Floor(FInput[i] * d) / d;
			}
			
			else if (FRounding[i] == Round.Floor)
			{
				double d = Math.Pow(10, FDigits[i]);
				FOutput[i] = Math.Floor(FInput[i] * d) / d;
				
			}
			
			else if (FRounding[i] == Round.Truncate)
			{
				double d = Math.Pow(10, FDigits[i]);
				FOutput[i] = Math.Truncate(FInput[i] * d) / d;
			}
			
			
			else if (FRounding[i] == Round.ToEven)
			FOutput[i] = Math.Round(FInput[i], Math.Max(0,Math.Min(15, FDigits[i])), MidpointRounding.ToEven );
			
			else if (FRounding[i] ==  Round.AwayFromZero)
			FOutput[i] = Math.Round(FInput[i], Math.Max(0,Math.Min(15, FDigits[i])), MidpointRounding.AwayFromZero );
			
		}
	}
}